(function(e, a) { for(var i in a) e[i] = a[i]; }(window, /******/ (function(modules) { // webpackBootstrap
    /******/ 	// The module cache
    /******/ 	var installedModules = {};
    /******/
    /******/ 	// The require function
    /******/ 	function __webpack_require__(moduleId) {
    /******/
    /******/ 		// Check if module is in cache
    /******/ 		if(installedModules[moduleId]) {
    /******/ 			return installedModules[moduleId].exports;
    /******/ 		}
    /******/ 		// Create a new module (and put it into the cache)
    /******/ 		var module = installedModules[moduleId] = {
    /******/ 			i: moduleId,
    /******/ 			l: false,
    /******/ 			exports: {}
    /******/ 		};
    /******/
    /******/ 		// Execute the module function
    /******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
    /******/
    /******/ 		// Flag the module as loaded
    /******/ 		module.l = true;
    /******/
    /******/ 		// Return the exports of the module
    /******/ 		return module.exports;
    /******/ 	}
    /******/
    /******/
    /******/ 	// expose the modules object (__webpack_modules__)
    /******/ 	__webpack_require__.m = modules;
    /******/
    /******/ 	// expose the module cache
    /******/ 	__webpack_require__.c = installedModules;
    /******/
    /******/ 	// identity function for calling harmony imports with the correct context
    /******/ 	__webpack_require__.i = function(value) { return value; };
    /******/
    /******/ 	// define getter function for harmony exports
    /******/ 	__webpack_require__.d = function(exports, name, getter) {
    /******/ 		if(!__webpack_require__.o(exports, name)) {
    /******/ 			Object.defineProperty(exports, name, {
    /******/ 				configurable: false,
    /******/ 				enumerable: true,
    /******/ 				get: getter
    /******/ 			});
    /******/ 		}
    /******/ 	};
    /******/
    /******/ 	// getDefaultExport function for compatibility with non-harmony modules
    /******/ 	__webpack_require__.n = function(module) {
    /******/ 		var getter = module && module.__esModule ?
    /******/ 			function getDefault() { return module['default']; } :
    /******/ 			function getModuleExports() { return module; };
    /******/ 		__webpack_require__.d(getter, 'a', getter);
    /******/ 		return getter;
    /******/ 	};
    /******/
    /******/ 	// Object.prototype.hasOwnProperty.call
    /******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
    /******/
    /******/ 	// __webpack_public_path__
    /******/ 	__webpack_require__.p = "";
    /******/
    /******/ 	// Load entry module and return exports
    /******/ 	return __webpack_require__(__webpack_require__.s = 3);
    /******/ })
    /************************************************************************/
    /******/ ([
    /* 0 */
    /***/ (function(module, exports, __webpack_require__) {

    "use strict";


    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

    exports.configEvent = configEvent;
    exports.hook = hook;
    exports.unHook = unHook;
    /*
     * author: wendux
     * email: 824783146@qq.com
     * source code: https://github.com/wendux/Ajax-hook
     */

    // Save original XMLHttpRequest as _rxhr
    var realXhr = "_rxhr";

    function configEvent(event, xhrProxy) {
        var e = {};
        for (var attr in event) {
            e[attr] = event[attr];
        } // xhrProxy instead
        e.target = e.currentTarget = xhrProxy;
        return e;
    }

    function hook(proxy) {
        // Avoid double hookAjax
        window[realXhr] = window[realXhr] || XMLHttpRequest;

        XMLHttpRequest = function XMLHttpRequest() {
            var xhr = new window[realXhr]();
            // We shouldn't hookAjax XMLHttpRequest.prototype because we can't
            // guarantee that all attributes are on the prototype。
            // Instead, hooking XMLHttpRequest instance can avoid this problem.
            for (var attr in xhr) {
                var type = "";
                try {
                    type = _typeof(xhr[attr]); // May cause exception on some browser
                } catch (e) {}
                if (type === "function") {
                    // hookAjax methods of xhr, such as `open`、`send` ...
                    this[attr] = hookFunction(attr);
                } else {
                    Object.defineProperty(this, attr, {
                        get: getterFactory(attr),
                        set: setterFactory(attr),
                        enumerable: true
                    });
                }
            }
            var that = this;
            xhr.getProxy = function () {
                return that;
            };
            this.xhr = xhr;
        };

        // Generate getter for attributes of xhr
        function getterFactory(attr) {
            return function () {
                var v = this.hasOwnProperty(attr + "_") ? this[attr + "_"] : this.xhr[attr];
                var attrGetterHook = (proxy[attr] || {})["getter"];
                return attrGetterHook && attrGetterHook(v, this) || v;
            };
        }

        // Generate setter for attributes of xhr; by this we have an opportunity
        // to hookAjax event callbacks （eg: `onload`） of xhr;
        function setterFactory(attr) {
            return function (v) {
                var xhr = this.xhr;
                var that = this;
                var hook = proxy[attr];
                // hookAjax  event callbacks such as `onload`、`onreadystatechange`...
                if (attr.substring(0, 2) === 'on') {
                    that[attr + "_"] = v;
                    xhr[attr] = function (e) {
                        e = configEvent(e, that);
                        var ret = proxy[attr] && proxy[attr].call(that, xhr, e);
                        ret || v.call(that, e);
                    };
                } else {
                    //If the attribute isn't writable, generate proxy attribute
                    var attrSetterHook = (hook || {})["setter"];
                    v = attrSetterHook && attrSetterHook(v, that) || v;
                    this[attr + "_"] = v;
                    try {
                        // Not all attributes of xhr are writable(setter may undefined).
                        xhr[attr] = v;
                    } catch (e) {}
                }
            };
        }

        // Hook methods of xhr.
        function hookFunction(fun) {
            return function () {
                var args = [].slice.call(arguments);
                if (proxy[fun]) {
                    var ret = proxy[fun].call(this, args, this.xhr);
                    // If the proxy return value exists, return it directly,
                    // otherwise call the function of xhr.
                    if (ret) return ret;
                }
                return this.xhr[fun].apply(this.xhr, args);
            };
        }

        // Return the real XMLHttpRequest
        return window[realXhr];
    }

    function unHook() {
        if (window[realXhr]) XMLHttpRequest = window[realXhr];
        window[realXhr] = undefined;
    }

    /***/ }),
    /* 1 */
    /***/ (function(module, exports, __webpack_require__) {

    "use strict";


    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.proxy = proxy;
    exports.unProxy = unProxy;

    var _xhrHook = __webpack_require__(0);

    var events = ['load', 'loadend', 'timeout', 'error', 'readystatechange', 'abort']; /*
                                                                                        * author: wendux
                                                                                        * email: 824783146@qq.com
                                                                                        * source code: https://github.com/wendux/Ajax-hook
                                                                                        */

    var eventLoad = events[0],
        eventLoadEnd = events[1],
        eventTimeout = events[2],
        eventError = events[3],
        eventReadyStateChange = events[4],
        eventAbort = events[5];

    var singleton,
        prototype = 'prototype';

    function proxy(proxy) {
        if (singleton) throw "Proxy already exists";
        return singleton = new Proxy(proxy);
    }

    function unProxy() {
        singleton = null;
        (0, _xhrHook.unHook)();
    }

    function trim(str) {
        return str.replace(/^\s+|\s+$/g, '');
    }

    function getEventTarget(xhr) {
        return xhr.watcher || (xhr.watcher = document.createElement('a'));
    }

    function triggerListener(xhr, name) {
        var xhrProxy = xhr.getProxy();
        var callback = 'on' + name + '_';
        var event = (0, _xhrHook.configEvent)({ type: name }, xhrProxy);
        xhrProxy[callback] && xhrProxy[callback](event);
        var evt;
        if (typeof Event === 'function') {
            evt = new Event(name, { bubbles: false });
        } else {
            // https://stackoverflow.com/questions/27176983/dispatchevent-not-working-in-ie11
            evt = document.createEvent('Event');
            evt.initEvent(name, false, true);
        }
        getEventTarget(xhr).dispatchEvent(evt);
    }

    function Handler(xhr) {
        this.xhr = xhr;
        this.xhrProxy = xhr.getProxy();
    }

    Handler[prototype] = Object.create({
        resolve: function resolve(response) {
            var xhrProxy = this.xhrProxy;
            var xhr = this.xhr;
            xhrProxy.readyState = 4;
            xhr.resHeader = response.headers;
            xhrProxy.response = xhrProxy.responseText = response.response;
            xhrProxy.statusText = response.statusText;
            xhrProxy.status = response.status;
            triggerListener(xhr, eventReadyStateChange);
            triggerListener(xhr, eventLoad);
            triggerListener(xhr, eventLoadEnd);
        },
        reject: function reject(error) {
            this.xhrProxy.status = 0;
            triggerListener(this.xhr, error.type);
            triggerListener(this.xhr, eventLoadEnd);
        }
    });

    function makeHandler(next) {
        function sub(xhr) {
            Handler.call(this, xhr);
        }

        sub[prototype] = Object.create(Handler[prototype]);
        sub[prototype].next = next;
        return sub;
    }

    var RequestHandler = makeHandler(function (rq) {
        var xhr = this.xhr;
        rq = rq || xhr.config;
        xhr.withCredentials = rq.withCredentials;
        xhr.open(rq.method, rq.url, rq.async !== false, rq.user, rq.password);
        for (var key in rq.headers) {
            xhr.setRequestHeader(key, rq.headers[key]);
        }
        xhr.send(rq.body);
    });

    var ResponseHandler = makeHandler(function (response) {
        this.resolve(response);
    });

    var ErrorHandler = makeHandler(function (error) {
        this.reject(error);
    });

    function Proxy(proxy) {
        var onRequest = proxy.onRequest,
            onResponse = proxy.onResponse,
            onError = proxy.onError;

        function handleResponse(xhr, xhrProxy) {
            var handler = new ResponseHandler(xhr);
            if (!onResponse) return handler.resolve();
            var ret = {
                response: xhrProxy.response,
                status: xhrProxy.status,
                statusText: xhrProxy.statusText,
                config: xhr.config,
                headers: xhr.resHeader || xhr.getAllResponseHeaders().split('\r\n').reduce(function (ob, str) {
                    if (str === "") return ob;
                    var m = str.split(":");
                    ob[m.shift()] = trim(m.join(':'));
                    return ob;
                }, {})
            };
            onResponse(ret, handler);
        }

        function onerror(xhr, xhrProxy, e) {
            var handler = new ErrorHandler(xhr);
            var error = { config: xhr.config, error: e };
            if (onError) {
                onError(error, handler);
            } else {
                handler.next(error);
            }
        }

        function preventXhrProxyCallback() {
            return true;
        }

        function errorCallback(xhr, e) {
            onerror(xhr, this, e);
            return true;
        }

        function stateChangeCallback(xhr, xhrProxy) {
            if (xhr.readyState === 4 && xhr.status !== 0) {
                handleResponse(xhr, xhrProxy);
            } else if (xhr.readyState !== 4) {
                triggerListener(xhr, eventReadyStateChange);
            }
            return true;
        }

        return (0, _xhrHook.hook)({
            onload: preventXhrProxyCallback,
            onloadend: preventXhrProxyCallback,
            onerror: errorCallback,
            ontimeout: errorCallback,
            onabort: errorCallback,
            onreadystatechange: function onreadystatechange(xhr) {
                return stateChangeCallback(xhr, this);
            },
            open: function open(args, xhr) {
                var _this = this;
                var config = xhr.config = { headers: {} };
                config.method = args[0];
                config.url = args[1];
                config.async = args[2];
                config.user = args[3];
                config.password = args[4];
                config.xhr = xhr;
                var evName = 'on' + eventReadyStateChange;
                if (!xhr[evName]) {
                    xhr[evName] = function () {
                        return stateChangeCallback(xhr, _this);
                    };
                }

                var defaultErrorHandler = function defaultErrorHandler(e) {
                    onerror(xhr, _this, (0, _xhrHook.configEvent)(e, _this));
                };
                [eventError, eventTimeout, eventAbort].forEach(function (e) {
                    var event = 'on' + e;
                    if (!xhr[event]) xhr[event] = defaultErrorHandler;
                });

                // 如果有请求拦截器，则在调用onRequest后再打开链接。因为onRequest最佳调用时机是在send前，
                // 所以我们在send拦截函数中再手动调用open，因此返回true阻止xhr.open调用。
                //
                // 如果没有请求拦截器，则不用阻断xhr.open调用
                if (onRequest) return true;
            },
            send: function send(args, xhr) {
                var config = xhr.config;
                config.withCredentials = xhr.withCredentials;
                config.body = args[0];
                if (onRequest) {
                    // In 'onRequest', we may call XHR's event handler, such as `xhr.onload`.
                    // However, XHR's event handler may not be set until xhr.send is called in
                    // the user's code, so we use `setTimeout` to avoid this situation
                    var req = function req() {
                        onRequest(config, new RequestHandler(xhr));
                    };
                    config.async === false ? req() : setTimeout(req);
                    return true;
                }
            },
            setRequestHeader: function setRequestHeader(args, xhr) {
                // Collect request headers
                xhr.config.headers[args[0].toLowerCase()] = args[1];
                return true;
            },
            addEventListener: function addEventListener(args, xhr) {
                var _this = this;
                if (events.indexOf(args[0]) !== -1) {
                    var handler = args[1];
                    getEventTarget(xhr).addEventListener(args[0], function (e) {
                        var event = (0, _xhrHook.configEvent)(e, _this);
                        event.type = args[0];
                        event.isTrusted = true;
                        handler.call(_this, event);
                    });
                    return true;
                }
            },
            getAllResponseHeaders: function getAllResponseHeaders(_, xhr) {
                var headers = xhr.resHeader;
                if (headers) {
                    var header = "";
                    for (var key in headers) {
                        header += key + ': ' + headers[key] + '\r\n';
                    }
                    return header;
                }
            },
            getResponseHeader: function getResponseHeader(args, xhr) {
                var headers = xhr.resHeader;
                if (headers) {
                    return headers[(args[0] || '').toLowerCase()];
                }
            }
        });
    }

    /***/ }),
    /* 2 */,
    /* 3 */
    /***/ (function(module, exports, __webpack_require__) {

    "use strict";


    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.ah = undefined;

    var _xhrHook = __webpack_require__(0);

    var _xhrProxy = __webpack_require__(1);

    // ah(ajax hook)
    /*
     * author: wendux
     * email: 824783146@qq.com
     * source code: https://github.com/wendux/Ajax-hook
     */

    var ah = exports.ah = {
      proxy: _xhrProxy.proxy,
      unProxy: _xhrProxy.unProxy,
      hook: _xhrHook.hook,
      unHook: _xhrHook.unHook
    };
/***/ })
/******/ ])));

(function (window) {
    if (window.ILADBlock) {
        return;
    }
    ;
    var ILADBlock = /** @class */ (function () {
        function ILADBlock() {
            this.delayMode = true;
            this.delayEcho = 15;
            this.delayExpandTime = 20;
            this.maxChildNodesLength = 10;
            this.interval = 100;
            this.intervalTime = null;
            this.eleQueue = [];
            this.eleQueueProcessCount = 20;
            this.observer = null;
            this.targetNode = document.documentElement;
            this.config = { childList: true, subtree: true};
        }
        ILADBlock.prototype.onBeforeLoad = function (e) {
            if (/^(?!https?:)[\w-]+:/.test(e.url))
                return;
            var type = "OTHER";
            var eventName = "error";
            switch(e.target.localName) {
                case "frame":
                case "iframe":
                    type = "SUBDOCUMENT";
                    eventName = "load";
                    break;
                case "img":
                case "input":
                    type = "IMAGE";
                    break;
                case "video":
                case "audio":
                case "source":
                    type = "MEDIA";
                    break;
                case "object":
                case "embed":
                    type = "OBJECT";
                    break;
                case "script":
                    type = "SCRIPT";
                    break;
                case "link":
                    if (/\bstylesheet\b/i.test(e.target.rel))
                        type = "STYLESHEET";
                    break;
            }
            let isSub = self !== top;
            var url = isSub?document.referrer:document.URL; //处理iframe情况
            let data = {};
            data['flag'] = 'IL';
            data['type'] = 1;
            data['url'] = url;
            data['source'] = [type];
            if (type !== "SUBDOCUMENT") {
                if (isSub) {
                    data['source'].push("SUBDOCUMENT")
                } else {
                    data['source'].push("DOCUMENT")
                }
            }
            let ptargetURL = new URL(e.url, url).href;
            if (ptargetURL===undefined) return;
            data['data'] = { targetURL: ptargetURL };
            var ret = window.ILJSBridge.syncCallNative('ADBlock', 'filter', { 'data': JSON.stringify(data)});
            if (ret === 'block') {
                // Work around bugs.webkit.org/show_bug.cgi?id=65412
                // Allow the resource to load, but hide it afterwards.
                // Probably a normal site will never reach 250.
                this._request_blockCount++;
                if (this._request_blockCount > 250) {
                    console.log("ABORTING: blocked over 250 requests, probably an infinite loading loop");
                    this._request_blockCount = 0;
                }
                e.preventDefault();
                // Safari doesn't dispatch the expected events for elements that have been
                // prevented from loading by having their "beforeload" event cancelled.
                // That is a "load" event for blocked frames, and an "error" event for
                // other blocked elements. We need to dispatch those events manually here
                // to avoid breaking element collapsing and pages that rely on those events.
                setTimeout(function() {
                    var evt = document.createEvent("Event");
                    evt.initEvent(eventName);
                    e.target.dispatchEvent(evt);
                }, 0);
            }
        };
        ILADBlock.prototype.getAttributes = function (node) {
            let attributes = {};
            if (!node) {
                return attributes;
            }
            let attributesLength = node.attributes?node.attributes.length:0;
            for(var i = 0; i < attributesLength; i++) {
                let it = node.attributes[i];
                let name = it.localName;
                let value = it.value;
                if (name !== 'il_style') {
                    attributes[name] = value;
                }
            }
            return attributes;
        };
        ILADBlock.prototype.makeNodeData = function (node, child = false) {
            let data = {};
            if (!node) {
                return data;
            }
            let childNodesLength = node.parentNode?(node.parentNode.childNodes?node.parentNode.childNodes.length:0):0;
            data["name"] = node.nodeName;
            data["index"] = 0;
            data["maxIndex"] = childNodesLength;
            data["attributes"] = this.getAttributes(node);
            if (childNodesLength < this.maxChildNodesLength) {
                for (let i = 0; i < childNodesLength; i++) {
                    let cNode = node.parentNode.childNodes[i];
                    if (cNode === node) {
                        data["index"] = i;
                        continue;
                    }
                    if(!child && cNode.nodeType === 1) {
                        if (data['childNodes'] === undefined) {
                            data['childNodes'] = [];
                        }
                        data['childNodes'].push(this.makeNodeData(cNode, true));
                    }
                    if (cNode.nodeType === 3) {
                        data["text"] = cNode.textContent;
                    }
                }
            }
            return data;
        };
        ILADBlock.prototype.getNodes = function (node) {
            let nodes = [];
            if (!node) {
                return nodes;
            }
            let tNode = node;
            while(tNode) {
                nodes.push(this.makeNodeData(tNode));
                tNode = tNode.parentNode;
            }
            return nodes;
        };
        ILADBlock.prototype.getNodesData = function (node) {
            let data = {};
            data['flag'] = 'IL';
            data['type'] = 2;
            data['url'] = document.URL;
            data['data'] = this.getNodes(node);
            data['node'] = node;
            return data;
        };
        ILADBlock.prototype.allChildNodes = function (node, type) {
            var allCN = [];
            let elements = node.getElementsByTagName("*");
            for (let n of elements) {
                if (n.nodeType === type &&
                    !this.filterNode(n)) {
                    allCN.push(n);
                }
            }
            return allCN;
        };
        ILADBlock.prototype.isElementInViewport = function (t) {
            var rect = t.getBoundingClientRect();
            return (
                rect.x < (window.innerWidth || document.documentElement.clientWidth) &&
                rect.y < (window.innerHeight || document.documentElement.clientHeight) &&
                ((rect.x + rect.width) > 0 || (rect.y + rect.height) > 0)
            );
        };
        ILADBlock.prototype.onceBlock = function (node) {
            if (!this.once) {
                ILADBlockInstance.block(node);
                this.once = true;
            }
        }
        ILADBlock.prototype.block = function (node) {
            let dataElementsInView = new Array();
            let delayDataElements = new Array();
            let all = this.allChildNodes(node, 1);
            all.push(node);
            for (let t of all) {
                if (!this.delayMode || this.isElementInViewport(t)) {
                    dataElementsInView.push(this.getNodesData(t))
                } else {
                    delayDataElements.push(this.getNodesData(t));
                }
            }
            let len = parseInt(delayDataElements.length/this.delayEcho);
            len = len<=0?1:len;
            let interval = 50;
            for(let i = 0; i < delayDataElements.length; i += len) {
                let subDelayDataElements = delayDataElements.slice(i, i+len)
                setTimeout(function() {
                    this.post(subDelayDataElements);
                }.bind(this), interval);
                interval+=this.delayExpandTime;
            }
            setTimeout(function() {
                this.post(dataElementsInView);
            }.bind(this), 0);
        };
        ILADBlock.prototype.post = function (ary) {
            if (ary.length <= 0 ) {
                return;
            }
            function replacer(key, value) {
                if (key === 'node') return undefined;
                else return value;
            }
            window.ILJSBridge.callNative('ADBlock', 'filter', { 'data': JSON.stringify(ary, replacer)}, function (data) {
                for (i of data) {
                    let dataElement = ary[i];
                    let node = dataElement['node'];
                    if (node) {
                        // node.style.display = 'none';
                        node.remove();
                    }
                }
            }.bind(this), function (data) {});
        };
        ILADBlock.prototype.nodeNameEqual = function (t, r) {
            return t.nodeName.toLowerCase() === r.toLowerCase();
        };
        ILADBlock.prototype.filterNode = function (t) {
            let list = ['meta', 'link', 'script', 'style', 'svg', 'g', 'path', 'em', 'head', 'html', 'button', 'body',
            'span', 'h1', 'h2', 'h3', 'h4', 'h5', 'li', 'i', 'ul', 'a', 'p', 'option', 'select', 'label', 'input', 'title',
            'br', 'aside', ''];
            let filter = false;
            for (n of list) {
                if (this.nodeNameEqual(t, n)) {
                    filter = true;
                    break;
                }
            }
            return filter;
        };
        ILADBlock.prototype.listenCallback = function (mutations, observer) {
            let elements = new Array();
            for(let mutation of mutations) {
                if (mutation.type == 'childList') {
                    for (let n of mutation.addedNodes) {
                        if (n.nodeType === Node.ELEMENT_NODE) {
                            if (!this.filterNode(n) &&
                                !elements.includes(n)) {
                                    elements.push(n);
                            }
                        }
                    }
                }
            }
            elements = Array.from(new Set(elements));
            let elementsInView = new Array();
            let delayElements = new Array();
            for (let t of elements) {
                if (!this.delayMode || this.isElementInViewport(t)) {
                    elementsInView.push(t);
                } else {
                    delayElements.push(t);
                }
            }
            let len = parseInt(delayElements.length/this.delayEcho);
            len = len<=0?1:len;
            let interval = 0;
            for(let i = 0; i < delayElements.length; i += len) {
                let subDelayElements = delayElements.slice(i, i+len)
                setTimeout(function() {
                    this.addBlockRunLoopQueue(subDelayElements);
                }.bind(this), interval);
                interval+=this.delayExpandTime;
            }
            this.addBlockRunLoopQueue(elementsInView);
        };
        ILADBlock.prototype.listenStop = function (observer) {
            var mutations = observer.takeRecords();
            if (mutations.length > 0) {
                this.listenCallback(mutations, observer);
            }
            observer.disconnect();
        };
        ILADBlock.prototype.listenStart = function (observer) {
            observer.observe(this.targetNode, this.config);
        };
        ILADBlock.prototype.listenElement = function () {
            if (!this.observer) {
                this.observer = new MutationObserver(this.listenCallback.bind(this));
            }
            this.listenStart(this.observer);
        };
        ILADBlock.prototype.listen = function () {
            this.blockRunLoopStart();
            this.listenElement();
            this.listenXHR();
        };
        ILADBlock.prototype.disconnect = function () {
            if (this.observer) {
                this.observer.disconnect();
            }
            this.blockRunLoopStop();
            this.disconnectXHR();
        };
        ILADBlock.prototype.addBlockRunLoopQueue = function (queue) {
            if (this.intervalTime === null) {
                this.blockRunLoopStart();
            }
            this.eleQueue.push(...queue);
        };
        ILADBlock.prototype.blockRunLoopStart = function () {
            this.blockRunLoopStop();
            this.intervalTime = setInterval(function () {
                this.blockRunLoop();
            }.bind(this), this.interval);
        };
        ILADBlock.prototype.blockRunLoopStop = function () {
            if (this.intervalTime !== null) {
                clearInterval(this.intervalTime);
                this.intervalTime = null;
                this.blockRunLoop();
            }
        };
        ILADBlock.prototype.blockRunLoop = function () {
            if (this.eleQueue.length > 0) {
                let tEleQueue = this.eleQueue.slice(0, this.eleQueueProcessCount);
                tEleQueue = Array.from(new Set(tEleQueue));
                for (let t of tEleQueue) {
                    this.block(t);
                }
                this.eleQueue.splice(0, this.eleQueueProcessCount);
            } else {
                this.blockRunLoopStop();
            }
        };
        ILADBlock.prototype.listenXHR = function () {
            this.disconnectXHR();
            ah.proxy({
                onRequest: (config, handler) => {
                    var type = "SCRIPT";
                    let isSub = self !== top;
                    var url = isSub?document.referrer:document.URL; //处理iframe情况
                    let data = {};
                    data['flag'] = 'IL';
                    data['type'] = 1;
                    data['url'] = url;
                    data['source'] = [type];
                    if (type !== "SUBDOCUMENT") {
                        if (isSub) {
                            data['source'].push("SUBDOCUMENT")
                        } else {
                            data['source'].push("DOCUMENT")
                        }
                    }
                    let ptargetURL = new URL(config.url, url).href;
                    if (ptargetURL===undefined) {
                        handler.next(config);
                        return;
                    }
                    data['data'] = { targetURL: ptargetURL };
                    var ret = window.ILJSBridge.syncCallNative('ADBlock', 'filter', { 'data': JSON.stringify(data)});
                    if (ret === 'block') {
                        handler.reject({
                            config: config,
                            type: 'error'
                        });
                    } else {
                        handler.next(config);
                    }
                },
                onError: (err, handler) => {
                    handler.next(err)
                },
                onResponse: (response, handler) => {
                    handler.next(response)
                }
            });
        };
        ILADBlock.prototype.disconnectXHR = function () {
            ah.unProxy();
        };
        return ILADBlock;
    }());
    var ILADBlockInstance = new ILADBlock();
    var ILADBlockConfig = /** @class */ (function () {
        function ILADBlockConfig() {
        }
        ILADBlockConfig.prototype.init = function () {
            window.ILADBlock = ILADBlockInstance;
            this.enable = false;
        };
        ILADBlockConfig.prototype.__defineGetter__('enable', function () { return this._enable; });
        ILADBlockConfig.prototype.__defineSetter__('enable', function (enable) {
            this._enable = enable;
            if (enable) {
                document.addEventListener('beforeload', ILADBlockInstance.onBeforeLoad, true);
                if (document.readyState === 'loading') {
                    this.root_once = false;
                    document.addEventListener('readystatechange', event => {
                        if (!this.root_once && event.target.readyState !== "loading") {
                            this.root_once = true;
                            ILADBlockInstance.block(document.documentElement);
                            ILADBlockInstance.listen();
                        }
                    });
                } else {
                    this.root_once = true;
                    ILADBlockInstance.block(document.documentElement);
                    ILADBlockInstance.listen();
                }
            } else {
                document.removeEventListener('beforeload', ILADBlockInstance.onBeforeLoad, true);
                ILADBlockInstance.disconnect();
            };
        });
        return ILADBlockConfig;
    }());
    window.ILADBlockConfig = new ILADBlockConfig();
    window.ILADBlockConfig.init();
})(window);
